package com.ynet.life.mvc;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEConstance;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.flow.GENEFlow;
import com.ynet.gene.log.GENELog;
import com.ynet.gene.session.GENESession;
import com.ynet.gene.session.InvalidSessionException;
import com.ynet.gene.session.Session;
import com.ynet.gene.session.SessionException;
import com.ynet.gene.transaction.GENETransactionManager;
import com.ynet.gene.web.servlet.ModelAndView;
import com.ynet.gene.web.servlet.mvc.BizLogicException;
import com.ynet.gene.web.servlet.mvc.GENEFlowExecuteResult;
import com.ynet.gene.web.servlet.mvc.GENERequestController;
import com.ynet.gene.web.servlet.mvc.InvalidInputException;
import com.ynet.gene.web.servlet.newmvc.InChargeOfMoreActions;
import com.ynet.life.base.LifeConstants;
import com.ynet.life.base.LifeDBAccess;
import com.ynet.life.base.MVCEntity;
import com.ynet.life.base.TEntity;
import com.ynet.life.base.Trace;
import com.ynet.life.exception.SessionKickoutException;
import com.ynet.life.exception.TranFailException;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.sql.Connection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.lang.StringUtils;
import org.json.JSONObject;

/* loaded from: com_ynet_life_mvc.jar:com/ynet/life/mvc/XMLViewRequestController.class */
public class XMLViewRequestController extends GENERequestController implements InChargeOfMoreActions {
    protected Map simpleRequests;
    private boolean checkSession = true;
    private String sessUserId = "";

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v12, types: [com.ynet.life.mvc.SimpleRequest, java.lang.Exception] */
    public ModelAndView doRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
        if (this.openMonitor) {
            this.accessInfo.newAccess();
        }
        Connection connection = null;
        ModelAndView modelAndView = null;
        Map model = null;
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        ?? r0 = (SimpleRequest) this.simpleRequests.get(actionId);
        r0.getBizId();
        try {
            if (r0 == 0) {
                throw new GENEException("SimpleRequest for " + actionId + " not found!");
            }
            try {
                System.out.println("当前请求URL========" + request.getRequestURI());
                if (r0.isCheckSession() && isCheckSession()) {
                    Session session = doSessionCheck(request, response);
                    if (session == null) {
                        Trace.logError("LifeSession", "Session not exist or timeout");
                        throw LifeConstants.EXCEPTION_SESSION_TIMEOUT;
                    }
                    String appKey = request.getParameter(TEntity.appKeyFieldname);
                    GENESession sessionGen = (GENESession) this.sessionManager.getSessions().get(appKey);
                    if (sessionGen != null) {
                        sessionGen.setLastAccessTime(System.currentTimeMillis());
                    }
                    if (request.getSession().getAttribute("appKey") != null && appKey != null && appKey != "" && !request.getSession().getAttribute("appKey").equals(appKey)) {
                        Trace.logError("LifeSession", "Session not exist or timeout");
                        throw LifeConstants.EXCEPTION_SESSION_TIMEOUT;
                    }
                    request.getSession().setAttribute("appKey", appKey);
                    MVCEntity mvcEntity = (MVCEntity) ((Session) this.sessionManager.getSessions().get(appKey)).getAttribute(appKey);
                    this.sessUserId = mvcEntity.getUserId();
                    if (!request.getSession().getId().equals(mvcEntity.getHttpSessionId())) {
                        Trace.logError("LifeSession", "Session not exist or timeout");
                        throw LifeConstants.EXCEPTION_SESSION_TIMEOUT;
                    }
                    String authFields = r0.getAuthFields();
                    if (StringUtils.isNotEmpty(authFields)) {
                        if (!authFields.contains(mvcEntity.getRoleType())) {
                            Trace.logError("LifeSession", "越权访问");
                            throw LifeConstants.EXCEPTION_SESSION_TIMEOUT;
                        }
                    } else {
                        connection = LifeDBAccess.getConnection();
                        String authCheckSql = " SELECT fibr.IBR_PAGEPATH FROM fsp_role_bsn_rel frbr  INNER JOIN fsp_interface_bsn_rel fibr ON frbr.RSR_BSNCODE = fibr.IBR_BSNCODE   WHERE frbr.RSR_ROLEID = '" + mvcEntity.getRoleId() + "' AND fibr.IBR_INTERFACE = '" + actionId + "'   UNION   SELECT fibr.IBR_PAGEPATH FROM fsp_role_bsn_rel frbr   INNER JOIN fsp_interface_bsn_rel fibr ON frbr.RSR_BSNCODE = fibr.IBR_BSNCODE   INNER JOIN fsp_pop_parents fpp ON fpp.POP_PARENTPATH = fibr.IBR_PAGEPATH   INNER JOIN fsp_interface_pop fip ON fip.IFP_PAGEPATH = fpp.POP_PAGEPATH AND fip.IFP_INTERFACE = '" + actionId + "'  WHERE frbr.RSR_ROLEID = '" + mvcEntity.getRoleId() + "' ";
                        Trace.logTrace("LifeAction", authCheckSql);
                        if (LifeDBAccess.queryMultipleResult(connection, authCheckSql, (List) null, 1).size() == 0) {
                            Trace.logError("LifeSession", "越权访问");
                            throw LifeConstants.EXCEPTION_SESSION_TIMEOUT;
                        }
                    }
                    request.getSession().setAttribute("appKey", appKey);
                    preActionWork(request, session, r0);
                    doSessionKickoutCheck(request, response);
                }
                ModelAndView modelAndView2 = executeTheFlow(request, response);
                dealWithSignOut(request, response, r0);
                LifeDBAccess.releaseConnection(connection);
                if (modelAndView2 != null) {
                    pstActionWork(request, (Context) modelAndView2.getModel().get(GENEConstance.ATTR_CONTEXT), null, r0);
                }
                return modelAndView2;
            } catch (Exception e) {
                r0.printStackTrace();
                if (e instanceof InvalidInputException) {
                    e.getModel();
                } else if (e instanceof BizLogicException) {
                    ((BizLogicException) e).getModel();
                }
                throw e;
            }
        } catch (Throwable th) {
            LifeDBAccess.releaseConnection((Connection) null);
            if (0 != 0) {
                pstActionWork(request, (Context) modelAndView.getModel().get(GENEConstance.ATTR_CONTEXT), null, r0);
            } else if (0 != 0) {
                pstActionWork(request, (Context) model.get(GENEConstance.ATTR_CONTEXT), null, r0);
            }
            throw th;
        }
    }

    protected JSONObject getPostParams(HttpServletRequest request, HttpServletResponse response) throws Exception {
        StringBuffer sb = new StringBuffer();
        BufferedReader br = new BufferedReader(new InputStreamReader((InputStream) request.getInputStream(), "utf-8"));
        while (true) {
            String s = br.readLine();
            if (s == null) {
                break;
            }
            sb.append(s);
        }
        if (sb.toString().length() <= 0) {
            return null;
        }
        return new JSONObject(sb.toString());
    }

    protected ModelAndView executeTheFlow(HttpServletRequest request, HttpServletResponse response) throws Exception {
        Session session = null;
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        SimpleRequest simpleRequest = (SimpleRequest) this.simpleRequests.get(actionId);
        if (simpleRequest.isCheckSession() && isCheckSession()) {
            Session initSession = initSession(request, response);
            session = initSession;
            if (initSession != null) {
                session.getAttribute(GENEConstance.ATTR_CONTEXT);
            }
        }
        if (isCheckDuplicateSubmit()) {
            doCheckDuplicateSubmit(request, response);
        }
        request.setAttribute(GENEConstance.GENE_SESSION, session);
        Map model = new HashMap();
        GENEFlowExecuteResult result = executeGENELogicBizFlow(request, response, session);
        model.put(GENEConstance.ATTR_CONTEXT, result.context);
        model.put(GENEConstance.ATTR_FLOW_OUTPUT, result.flow.getOutput(simpleRequest.getOpId()));
        if (result.e != null) {
            if (result.e instanceof InvalidInputException) {
                result.e.setModel(model);
                throw result.e;
            }
            if (result.e instanceof InvalidSessionException) {
                this.sessionManager.removeSession(session);
                throw new BizLogicException(model, result.e);
            }
            throw new BizLogicException(model, result.e);
        }
        return new ModelAndView(model, new XMLView());
    }

    protected GENEFlowExecuteResult executeGENELogic(Context sessionContext, HttpServletRequest request, HttpServletResponse response) {
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        SimpleRequest simpleRequest = (SimpleRequest) this.simpleRequests.get(actionId);
        GENEFlowExecuteResult result = new GENEFlowExecuteResult();
        GENETransactionManager transactionManager = null;
        String flowId = simpleRequest.getBizId();
        GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "begin to execute flow " + flowId + " ...");
        String opId = simpleRequest.getOpId();
        try {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Get flow " + flowId + "  from factory...");
            GENEFlow flow = this.geneFactory.getGENEFlow(flowId);
            result.flow = flow;
            Context context = (Context) flow.getContext().clone();
            result.context = context;
            if (sessionContext != null && context.getParentContextName() == null) {
                context.chainedTo(sessionContext);
            }
            transactionManager = (GENETransactionManager) context.getService(GENEConstance.TRX_SVC_NAME);
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Update the request data ...");
            doUpdateModel(request, context, flow, opId);
            doPreprocessModelData(request, context, flow, opId);
            addDataField(context, GENEConstance.SERVLET_REQUEST, request);
            String retValue = flow.execute(context, opId);
            if (transactionManager != null) {
                transactionManager.commit();
            }
            result.result = retValue;
        } catch (Exception e) {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.ERROR, 0, "Failed to execute flow ".concat(String.valueOf(flowId)), e);
            result.e = e;
            if (transactionManager != null) {
                transactionManager.rollback();
            }
        }
        return result;
    }

    protected GENEFlowExecuteResult executeGENELogicBizFlow(HttpServletRequest request, HttpServletResponse response, Session session) {
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        SimpleRequest simpleRequest = (SimpleRequest) this.simpleRequests.get(actionId);
        GENEFlowExecuteResult result = new GENEFlowExecuteResult();
        GENETransactionManager transactionManager = null;
        String flowId = simpleRequest.getBizId();
        GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "begin to execute flow " + flowId + " ...");
        GENEFlowExecuteResult opId = simpleRequest.getOpId();
        try {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Get flow " + flowId + "  from factory...");
            GENEFlow flow = this.geneFactory.getGENEFlow(flowId);
            result.flow = flow;
            Context context = (Context) flow.getContext().clone();
            result.context = context;
            transactionManager = (GENETransactionManager) context.getService(GENEConstance.TRX_SVC_NAME);
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Update the request data ...");
            doUpdateModel(request, context, flow, opId);
            doPreprocessModelData(request, context, flow, opId);
            addDataField(context, GENEConstance.SERVLET_REQUEST, request);
            preContextWork(request, context, simpleRequest);
            String retValue = flow.execute(context, opId);
            if (transactionManager != null) {
                transactionManager.commit();
            }
            opId = result;
            opId.result = retValue;
        } catch (Exception e) {
            opId.printStackTrace();
            GENELog.log(GENEConstance.GENE_MVC, GENELog.ERROR, 0, "Failed to execute flow ".concat(String.valueOf(flowId)), e);
            result.e = e;
            if (transactionManager != null) {
                transactionManager.rollback();
            }
        }
        return result;
    }

    public boolean isInCharge(HttpServletRequest request) {
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        if (this.simpleRequests != null && this.simpleRequests.containsKey(actionId)) {
            return true;
        }
        return false;
    }

    public void addSimpleRequest(SimpleRequest simpleRequest) {
        if (this.simpleRequests == null) {
            this.simpleRequests = new HashMap();
        }
        this.simpleRequests.put(simpleRequest.getId(), simpleRequest);
    }

    protected void preActionWork(HttpServletRequest request, Session session, SimpleRequest simpleRequest) throws TranFailException {
    }

    protected void pstActionWork(HttpServletRequest request, Context context, Throwable throwable, SimpleRequest simpleRequest) throws TranFailException {
    }

    protected void preContextWork(HttpServletRequest request, Context context, SimpleRequest simpleRequest) throws TranFailException {
    }

    public ModelAndView handleException(HttpServletRequest request, HttpServletResponse response, Exception e) {
        Map model = new HashMap();
        model.put(GENEConstance.ATTR_EXCEPTION, e);
        return new ModelAndView(model, new MVCXmlView());
    }

    private void doSessionKickoutCheck(HttpServletRequest request, HttpServletResponse response) throws Exception {
        if (this.sessionManager == null) {
            throw new GENEException("Session manager not set for the GENE component factory! please set it in common Service and set aliasName as [GENESessionManager] parameter in web.xml");
        }
        request.getParameter(TEntity.appKeyFieldname);
        Session session = this.sessionManager.getSession(request, response, false);
        if (session != null) {
            String sessionKickoutFlag = (String) session.getAttribute("sessionKickoutFlag");
            if (LifeConstants.FIELD_SUCC_FLAG_TRUE.equals(sessionKickoutFlag)) {
                clearCookies(request, response, "/");
                this.sessionManager.removeSession(session);
                throw new SessionKickoutException();
            }
        }
    }

    protected Session doSessionCheck(HttpServletRequest request, HttpServletResponse response) throws Exception {
        if (this.checkSession && this.sessionManager == null) {
            throw new GENEException("Session manager not set for the GENE component factory! please set it in common Service and set aliasName as [GENESessionManager] parameter in web.xml");
        }
        if ((isCheckVerifyPin() || isUseSoftKeyPin()) && this.sessionManager == null) {
            throw new GENEException("Session manager not set for the GENE component factory! please set it in common Service and set aliasName as [GENESessionManager] parameter in web.xml，the GENE verifyPin and keyboard use the session to keep server side infos, please set the session manager!");
        }
        if (this.sessionManager != null) {
            GENESession sessionTime = this.sessionManager.getSession(request, response, false);
            if (sessionTime == null) {
                clearCookies(request, response, "/");
                throw new SessionException("长时间无操作，系统自动退出登录");
            }
            sessionTime.setLastAccessTime(System.currentTimeMillis());
            System.out.println("当前sessionId===" + sessionTime.getId() + "===" + request.getParameter(TEntity.appKeyFieldname));
            System.out.println("当前sessionTime===" + sessionTime.getLastAccessTime());
            Session session = this.sessionManager.getSession(request, response, false);
            Session session2 = session;
            if (session == null) {
                if (this.checkSession) {
                    clearCookies(request, response, "/");
                    throw new SessionException("长时间无操作，系统自动退出登录");
                }
                if (isCheckVerifyPin() || isUseSoftKeyPin()) {
                    session2 = this.sessionManager.getSession(request, response, true);
                }
            }
            return session2;
        }
        return null;
    }

    protected void dealWithSignOut(HttpServletRequest request, HttpServletResponse response, SimpleRequest simpleRequest) {
        if (simpleRequest != null && simpleRequest.isClearCookieFlag()) {
            clearCookies(request, response, "/");
        }
    }

    protected void clearCookies(HttpServletRequest request, HttpServletResponse response, String path) {
        Cookie[] cookies = request.getCookies();
        for (Cookie cookie : cookies) {
            try {
                Cookie cookie2 = new Cookie(cookie.getName(), (String) null);
                cookie2.setMaxAge(0);
                cookie2.setPath(path);
                response.addCookie(cookie2);
            } catch (Exception unused) {
                GENELog.log(GENEConstance.GENE_MVC, GENELog.ERROR, 0, "清空cookie数据异常!");
                return;
            }
        }
    }

    public String getMD5(byte[] source) throws TranFailException {
        String result = null;
        char[] hexDigits = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            md.update(source);
            byte[] tmp = md.digest();
            char[] str = new char[32];
            int k = 0;
            for (int i = 0; i < 16; i++) {
                byte byte0 = tmp[i];
                int i2 = k;
                int k2 = k + 1;
                str[i2] = hexDigits[(byte0 >>> 4) & 15];
                k = k2 + 1;
                str[k2] = hexDigits[byte0 & 15];
            }
            result = new String(str);
        } catch (Exception e) {
            new TranFailException("EBLN0000", e);
        }
        return result;
    }

    public static void main(String[] args) {
        System.out.println(URLEncoder.encode("IZKvFQYQUGlPdqSrVZYaYq9p5l+tYIF7Iap55NswSWiQvovc4mEn1P6WvTKv5BYd"));
    }
}
